﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.3
@EndOfDesignText@
'Custom View class
'version: 2.00
#DesignerProperty: Key: ColorFull, DisplayName: Color Full, FieldType: Color, DefaultValue: 0xFF06F96B, Description:
#DesignerProperty: Key: ColorEmpty, DisplayName: Color Empty, FieldType: Color, DefaultValue: 0xFF868686, Description:
#DesignerProperty: Key: StrokeWidth, DisplayName: Stroke Width, FieldType: Int, DefaultValue: 10, Description:
#DesignerProperty: Key: Duration, DisplayName: Duration From 0 To 100, FieldType: Int, DefaultValue: 3000, Description: Milliseconds

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private cvs As B4XCanvas
	Private xui As XUI
	Private mLbl As B4XView
	Private cx, cy, radius As Float
	Private stroke As Float
	Private clrFull, clrEmpty As Int
	Private mBase As B4XView
	Private currentValue As Float = 18.0
	Private DurationFromZeroTo100 As Int
	Private manager As ManagerEvent
	Private minv, maxv As Int
	Private current_pos As Float= 18.1
	Private pas As Float
	Private Offset As Float=10.0
	Private Max_val As Float=20.0
	Private TouchScale As Float=0.1
	Private SweepScale As Float=1
	
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	manager.Initialize(Me)
End Sub

Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	manager.SetEvent(mBase,"mBase")
	mBase.SetLayoutAnimated(0, mBase.Left, mBase.Top,  Min(mBase.Width, mBase.Height), Min(mBase.Width, mBase.Height))
	minv=Min(mBase.Width, mBase.Height)
	maxv=Max(mBase.Width, mBase.Height)
	clrFull = xui.PaintOrColorToColor(Props.Get("ColorFull"))
	clrEmpty = xui.PaintOrColorToColor(Props.Get("ColorEmpty"))
	stroke = DipToCurrent(Props.Get("StrokeWidth"))
	DurationFromZeroTo100 = Props.Get("Duration")
	mLbl = Lbl
	cx = mBase.Width / 2
	cy = mBase.Height / 2
	radius = cx - 10dip
	cvs.Initialize(mBase)
	mLbl.SetTextAlignment("CENTER", "CENTER")
	mBase.AddView(mLbl, 0, cy - 20dip, mBase.Width, 40dip)
	cvs.Initialize(mBase)
	DrawValue(currentValue)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	cx = Width / 2
	cy = Height / 2
	radius = cx - 10dip
	mBase.SetLayoutAnimated(0, mBase.Left, mBase.Top,  Min(Width,Height), Min(Width, Height))
	cvs.Resize(Width, Height)
	mLbl.SetLayoutAnimated(0, 0, cy - 20dip, Width, 40dip)
	DrawValue(currentValue)
End Sub

Public Sub setValue(NewValue As Float)
	DrawValue(NewValue)
End Sub

Public Sub getValue As Float
	Return currentValue+Offset
End Sub

Public Sub set_MaxValue(MaxValue As Float)
	Max_val=MaxValue+Offset
End Sub

public Sub get_MaxValue As Float
	Return Max_val
End Sub

Public Sub set_Touch_Scale(Touch_Scale As Float)
	TouchScale=TouchScale
End Sub

public Sub get_Touch_Scale As Float
	Return Max_val
End Sub

Public Sub set_Sweep_Scale(Sweep_Scale As Float)
	SweepScale=Sweep_Scale
End Sub

public Sub get_Sweep_Scale As Float
	Return SweepScale
End Sub

Public Sub set_Offset(OffsetValue As Float)
	Offset=OffsetValue
End Sub

Public Sub get_Offset As Float
	Return Offset
End Sub



Private Sub AnimateValueTo(NewValue As Float)
	Dim n As Long = DateTime.Now
	Dim duration As Int = Abs(currentValue - NewValue) / 100 * DurationFromZeroTo100 + 1000
	Dim start As Float = currentValue
	currentValue = NewValue
	Dim tempValue As Float
	Do While DateTime.Now < n + duration
		tempValue = ValueFromTimeEaseInOut(DateTime.Now - n, start, NewValue - start, duration)
		DrawValue(tempValue)
		Sleep(10)
		If NewValue <> currentValue Then Return 'will happen if another update has started
	Loop
	DrawValue(currentValue)
End Sub

'quartic easing in/out from http://gizma.com/easing/
Private Sub ValueFromTimeEaseInOut(Time As Float, Start As Float, ChangeInValue As Float, Duration As Int) As Float
	Time = Time / (Duration / 2)
	If Time < 1 Then
		Return ChangeInValue / 2 * Time * Time * Time * Time + Start
	Else
		Time = Time - 2
		Return -ChangeInValue / 2 * (Time * Time * Time * Time - 2) + Start
	End If
End Sub

Private Sub DrawValue(Value As Float)
	cvs.ClearRect(cvs.TargetRect)
	cvs.DrawCircle(cx, cy, radius, clrEmpty, False, stroke)
	mLbl.Text = $"$1.1{Value+Offset}"$ & "°C"
	Dim startAngle = -90, sweepAngle = Value/ Max_val * 360 As Float

	If Value < Max_val Then
		Dim p As B4XPath
		p.InitializeArc(cx, cy, radius + stroke + 1dip, startAngle, sweepAngle)
		cvs.ClipPath(p)
		cvs.DrawCircle(cx, cy, radius - 0.5dip, clrFull, False, stroke + 1dip)
		cvs.RemoveClip
	Else
		cvs.DrawCircle(cx, cy, radius - 0.5dip, clrFull, False, stroke + 1dip)
	End If
	cvs.Invalidate
End Sub

Private Sub mbase_TouchEvent(action As Int, Coordinate() As TCoordinate)
	'Log(action)
	
	If action=2 Then 'Définition du pas en mode touch
		'Log($"Mbase: ${action}- X:${Coordinate(0).X} Y:${Coordinate(0).y}"$)
		pas=0.5
		Dim teta As Float = RtoAngle(Coordinate(0).x,Coordinate(0).y)
		If  teta < Max_val Then DrawValue(teta)
	else if action=0 Then 'Définition du pas en mode sweep
		pas=0.1
		Dim teta As Float = RtoAngle(Coordinate(0).x,Coordinate(0).y)
		If teta < Max_val Then DrawValue(teta)
		'Return True
'		If Coordinate(0).Y>570 Then
			'Log($"Mbase: ${action}- Y:${Coordinate(0).y}"$)
'		End If
	End If
End Sub

Private Sub RtoAngle(X As Float, Y As Float) As Float
	'
	Dim teta As Float
	
	If Y <> 0 Then
		
		
		'teta =Max_val+( ATan2D((X-cx),(cy-Y)) /Max_val)' * 32 '28     '0 to 180°
		teta = (ATan2D((X-cx),(cy-Y))/180)*(Max_val/2) 'Calcul du rayon rapporté à la valeur Max définie
		
				
		If teta < 0  Then 'à -180° (soit -Max_val/2) on calcule la difference à ajouter
			teta=(Max_val/2)+((Max_val/2)-Abs(teta))
		End If
		
		'Log(teta)
		
		
		'Détection du Min/max
		If teta < ((Max_val/2)*60)/100 And current_pos>Max_val/2 Then
			'Log("Max")
			teta=Max_val-0.1
		Else if teta > ((Max_val)*80)/100 And current_pos<Max_val/2 Then
			'Log("Min")
			teta=0.1
		End If
		
		' Résolution par pas défini
		If teta>current_pos  Then
			teta=current_pos+pas
		Else if teta<current_pos Then
			teta=current_pos-pas
		End If
		
		
		
		Log(((Max_val/2)*60)/100)
			
		current_pos=teta
		Return teta
		
	Else
		If (X-cx) > 0 Then teta = 235 Else teta = 45
	End If
	
	
	
End Sub


